VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   5715
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   7845
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   381
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   523
   StartUpPosition =   3  'Windows Default
   Begin VB.OptionButton radEnd 
      Caption         =   "Ending Tile"
      Height          =   375
      Left            =   5760
      TabIndex        =   3
      Top             =   480
      Width           =   1935
   End
   Begin VB.OptionButton radStart 
      Caption         =   "Starting Tile"
      Height          =   375
      Left            =   5760
      TabIndex        =   2
      Top             =   120
      Width           =   1935
   End
   Begin VB.CheckBox radWall 
      Caption         =   "Wall Tile"
      Height          =   375
      Left            =   5760
      TabIndex        =   1
      Top             =   840
      Width           =   1935
   End
   Begin VB.PictureBox picMain 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   5415
      Left            =   120
      ScaleHeight     =   5415
      ScaleWidth      =   5415
      TabIndex        =   0
      Tag             =   "0"
      Top             =   120
      Width           =   5415
   End
   Begin VB.OptionButton radDummy 
      Caption         =   "Dummy"
      Height          =   375
      Left            =   5760
      TabIndex        =   4
      Top             =   840
      Width           =   2055
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    
    Main
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    Shutdown

End Sub

Private Sub picMain_KeyDown(KeyCode As Integer, Shift As Integer)

    Select Case KeyCode
        Case BUTTON_UP
            Key_State = Key_State Or BUTTON_UP_FLAG
        Case BUTTON_DOWN
            Key_State = Key_State Or BUTTON_DOWN_FLAG
        Case BUTTON_LEFT
            Key_State = Key_State Or BUTTON_LEFT_FLAG
        Case BUTTON_RIGHT
            Key_State = Key_State Or BUTTON_RIGHT_FLAG
        Case BUTTON2_UP
            Key_State = Key_State Or BUTTON2_UP_FLAG
        Case BUTTON2_DOWN
            Key_State = Key_State Or BUTTON2_DOWN_FLAG
        Case BUTTON2_LEFT
            Key_State = Key_State Or BUTTON2_LEFT_FLAG
        Case BUTTON2_RIGHT
            Key_State = Key_State Or BUTTON2_RIGHT_FLAG
    End Select

End Sub

Private Sub picMain_KeyUp(KeyCode As Integer, Shift As Integer)

    Select Case KeyCode
        Case BUTTON_UP
            Key_State = Key_State And (Not BUTTON_UP_FLAG)
        Case BUTTON_DOWN
            Key_State = Key_State And (Not BUTTON_DOWN_FLAG)
        Case BUTTON_LEFT
            Key_State = Key_State And (Not BUTTON_LEFT_FLAG)
        Case BUTTON_RIGHT
            Key_State = Key_State And (Not BUTTON_RIGHT_FLAG)
        Case BUTTON2_UP
            Key_State = Key_State And (Not BUTTON2_UP_FLAG)
        Case BUTTON2_DOWN
            Key_State = Key_State And (Not BUTTON2_DOWN_FLAG)
        Case BUTTON2_LEFT
            Key_State = Key_State And (Not BUTTON2_LEFT_FLAG)
        Case BUTTON2_RIGHT
            Key_State = Key_State And (Not BUTTON2_RIGHT_FLAG)
    End Select

End Sub

Private Sub picMain_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If Button = 1 Then
        Mouse.X = X
        Mouse.Y = Y
        Cursor.X = X \ TILE_SIZE
        Cursor.Y = Y \ TILE_SIZE
        
        If Cursor.X <= 0 Then Cursor.X = 0
        If Cursor.Y <= 0 Then Cursor.Y = 0
        If Cursor.X >= Map.Width - 1 Then Cursor.X = Map.Width - 1
        If Cursor.Y >= Map.Height - 1 Then Cursor.Y = Map.Height - 1
        
        Mouse_Held = True
    End If

End Sub

Private Sub picMain_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Cursor.X = X \ TILE_SIZE
    Cursor.Y = Y \ TILE_SIZE
    
    If Cursor.X <= 0 Then Cursor.X = 0
    If Cursor.Y <= 0 Then Cursor.Y = 0
    If Cursor.X >= Map.Width - 1 Then Cursor.X = Map.Width - 1
    If Cursor.Y >= Map.Height - 1 Then Cursor.Y = Map.Height - 1
    
    If Mouse_Held = True Then
        Monster.Compute_AStar_Enabled = True
        Clear_AStar Map
    End If
        
    frmMain.Caption = Cursor.X & ", " & Cursor.Y & " | " & "Collidable: " & Map.Collision_Map.Response(Cursor.X, Cursor.Y) & " | " & Cursor.X * TILE_SIZE & ", " & Cursor.Y * TILE_SIZE

End Sub

Private Sub picMain_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If Button = 1 Then
        Mouse_Held = False
    End If

End Sub

Private Sub radEnd_Click()

    radWall.Value = 0
    
End Sub

Private Sub radStart_Click()

    radWall.Value = 0

End Sub

Private Sub radWall_Click()

    radDummy.Value = 1

End Sub
